module JF; end

class JF::MetaObserver
    def initialize
	# define default methods that prints out event name and arguments passed.
	@c = 0
	#Sketchup::AppObserver.instance_methods(false).each              {|m| self.class.send(:define_method, m) {|*a| @c+=1;puts "#{@c}:#{m}:#{a.inspect}" }}
	Sketchup::DefinitionObserver.instance_methods(false).each       {|m| self.class.send(:define_method, m) {|*a| @c+=1;puts "#{@c}:#{m}:#{a.inspect}" }}
	Sketchup::LayersObserver.instance_methods(false).each           {|m| self.class.send(:define_method, m) {|*a| @c+=1;puts "#{@c}:#{m}:#{a.inspect}" }}
	Sketchup::MaterialsObserver.instance_methods(false).each        {|m| self.class.send(:define_method, m) {|*a| @c+=1;puts "#{@c}:#{m}:#{a.inspect}" }}
	Sketchup::ModelObserver.instance_methods(false).each            {|m| self.class.send(:define_method, m) {|*a| @c+=1;puts "#{@c}:#{m}:#{a.inspect}" }}
	Sketchup::PagesObserver.instance_methods(false).each            {|m| self.class.send(:define_method, m) {|*a| @c+=1;puts "#{@c}:#{m}:#{a.inspect}" }}
	Sketchup::RenderingOptionsObserver.instance_methods(false).each {|m| self.class.send(:define_method, m) {|*a| @c+=1;puts "#{@c}:#{m}:#{a.inspect}" }}
	Sketchup::SelectionObserver.instance_methods(false).each        {|m| self.class.send(:define_method, m) {|*a| @c+=1;puts "#{@c}:#{m}:#{a.inspect}" }}
	Sketchup::ShadowInfoObserver.instance_methods(false).each       {|m| self.class.send(:define_method, m) {|*a| @c+=1;puts "#{@c}:#{m}:#{a.inspect}" }}
	Sketchup::ToolsObserver.instance_methods(false).each            {|m| self.class.send(:define_method, m) {|*a| @c+=1;puts "#{@c}:#{m}:#{a.inspect}" }}
	#Sketchup::ViewObserver.instance_methods(false).each             {|m| self.class.send(:define_method, m) {|*a| @c+=1;puts "#{@c}:#{m}:#{a.inspect}" }}
	
	# Observers not included:
	#   DefinitionObserver
	#   EntitiesObserver
	#   EntityObserver
	#   InstanceObserver
	#   OptionsProviderObserver
	
	#Sketchup.add_observer(self)
    end

    def user_attach
	attach unless @attached
	@attached = true
    end
    def user_detach
	detach
	@attached = false
    end

    def attach(model = Sketchup.active_model)
	Sketchup.add_observer(self)
	model.add_observer(self)
	model.definitions.add_observer(self)
	model.layers.add_observer(self)
	model.materials.add_observer(self)
	model.pages.add_observer(self)
	model.rendering_options.add_observer(self)
	model.selection.add_observer(self)
	model.shadow_info.add_observer(self)
	model.tools.add_observer(self)
	#model.active_view.add_observer(self) # Just too noisy!
    end

    def detach
	Sketchup.active_model.remove_observer(self)
	Sketchup.active_model.definitions.remove_observer(self)
	Sketchup.active_model.layers.remove_observer(self)
	Sketchup.active_model.materials.remove_observer(self)
	Sketchup.active_model.pages.remove_observer(self)
	Sketchup.active_model.rendering_options.remove_observer(self)
	Sketchup.active_model.selection.remove_observer(self)
	Sketchup.active_model.shadow_info.remove_observer(self)
	Sketchup.active_model.tools.remove_observer(self)
	Sketchup.active_model.active_view.remove_observer(self)
	Sketchup.remove_observer(self)
    end

    #
    # Need to re-attach all our observers after starting/opening a new model
    def onNewModel(*args)
	@c = 0
	puts "#{@c}:onNewModel:#{args.inspect}"
	detach
	attach if @attached
    end
    def onOpenModel(*args)
	@c=0
	puts "#{@c}:onOpenModel:#{args.inspect}"
	detach
	attach if @attached
    end
    def onQuit(*args)
	@c+=1
	puts "#{@c}:onQuit:#{args.inspect}"
	#detach
    end
    def onUnloadExtension(*args)
	@c+=1
	puts "#{@c}:onUnloadExtension:#{args.inspect}"
    end

end

$jf_meta_observer = JF::MetaObserver.new
UI.menu.add_item("Meta Observer Attach") { $jf_meta_observer.user_attach }
UI.menu.add_item("Meta Observer Detach") { $jf_meta_observer.user_detach }
